//
// Generated by JTB 1.3.2
//

package org.ow2.mind.idl.jtb.visitor;
import org.ow2.mind.idl.jtb.syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class GJDepthFirst<R,A> implements GJVisitor<R,A> {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public R visit(NodeList n, A argu) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeListOptional n, A argu) {
      if ( n.present() ) {
         R _ret=null;
         int _count=0;
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
            e.nextElement().accept(this,argu);
            _count++;
         }
         return _ret;
      }
      else
         return null;
   }

   public R visit(NodeOptional n, A argu) {
      if ( n.present() )
         return n.node.accept(this,argu);
      else
         return null;
   }

   public R visit(NodeSequence n, A argu) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeToken n, A argu) { return null; }

   //
   // User-generated visitor methods below
   //

   /**
    * <PRE>
    * f0 -> ( IncludeDirective() )*
    * f1 -> ( ( TypeDefinition() | ConstantDefinition() ) )*
    * f2 -> InterfaceDefinition()
    * f3 -> [ &lt;SEMICOLON&gt; ]
    * f4 -> &lt;EOF&gt;
    * </PRE>
    */
   public R visit(ITFFile n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;PREPROC_START&gt;
    * f1 -> &lt;PREPROC_IFNDEF&gt;
    * f2 -> &lt;PREPROC_IDENTIFIER&gt;
    * f3 -> &lt;PREPROC_ROL&gt;
    * f4 -> &lt;PREPROC_START&gt;
    * f5 -> &lt;PREPROC_DEFINE&gt;
    * f6 -> &lt;PREPROC_IDENTIFIER&gt;
    * f7 -> &lt;PREPROC_ROL&gt;
    * f8 -> ( IncludeDirective() )*
    * f9 -> ( ( TypeDefinition() | ConstantDefinition() ) )*
    * f10 -> &lt;PREPROC_START&gt;
    * f11 -> &lt;PREPROC_ENDIF&gt;
    * f12 -> [ &lt;PREPROC_ROL&gt; ]
    * f13 -> &lt;EOF&gt;
    * </PRE>
    */
   public R visit(IDTFile n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      n.f8.accept(this, argu);
      n.f9.accept(this, argu);
      n.f10.accept(this, argu);
      n.f11.accept(this, argu);
      n.f12.accept(this, argu);
      n.f13.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;PREPROC_START&gt;
    * f1 -> &lt;PREPROC_INCLUDE&gt;
    * f2 -> &lt;PREPROC_PATH&gt;
    * f3 -> &lt;PREPROC_ROL&gt;
    * </PRE>
    */
   public R visit(IncludeDirective n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;PREPROC_START&gt;
    * f1 -> &lt;PREPROC_DEFINE&gt;
    * f2 -> &lt;PREPROC_IDENTIFIER&gt;
    * f3 -> &lt;PREPROC_ROL&gt;
    * </PRE>
    */
   public R visit(ConstantDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> ( TypeDefSpecification() | StructOrUnionSpecification() | EnumSpecification() )
    * f1 -> &lt;SEMICOLON&gt;
    * </PRE>
    */
   public R visit(TypeDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;TYPEDEF&gt;
    * f1 -> QualifiedTypeSpecification()
    * f2 -> Declarators()
    * </PRE>
    */
   public R visit(TypeDefSpecification n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> ( TypeQualifier() )*
    * f1 -> TypeSpecification()
    * </PRE>
    */
   public R visit(QualifiedTypeSpecification n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;CONST&gt;
    *       | &lt;VOLATILE&gt;
    * </PRE>
    */
   public R visit(TypeQualifier n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> TypeDefName()
    *       | StructOrUnionSpecification()
    *       | EnumSpecification()
    *       | TypeSpecifiers()
    * </PRE>
    */
   public R visit(TypeSpecification n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> FullyQualifiedName()
    * </PRE>
    */
   public R visit(TypeDefName n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> ( &lt;VOID&gt; | &lt;CHAR&gt; | &lt;SHORT&gt; | &lt;INT&gt; | &lt;LONG&gt; | &lt;FLOAT&gt; | &lt;DOUBLE&gt; | &lt;SIGNED&gt; | &lt;UNSIGNED&gt; | &lt;STRING&gt; | &lt;INT8_T&gt; | &lt;UINT8_T&gt; | &lt;INT16_T&gt; | &lt;UINT16_T&gt; | &lt;INT32_T&gt; | &lt;UINT32_T&gt; | &lt;INT64_T&gt; | &lt;UINT64_T&gt; | &lt;INTPTR_T&gt; | &lt;UINTPTR_T&gt; )+
    * </PRE>
    */
   public R visit(TypeSpecifiers n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> StructOrUnionDefinition()
    *       | StructOrUnionReference()
    * </PRE>
    */
   public R visit(StructOrUnionSpecification n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> StructOrUnion()
    * f1 -> [ &lt;IDENTIFIER&gt; ]
    * f2 -> &lt;LBRACE&gt;
    * f3 -> StructMemberList()
    * f4 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(StructOrUnionDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> StructOrUnion()
    * f1 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(StructOrUnionReference n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;STRUCT&gt;
    *       | &lt;UNION&gt;
    * </PRE>
    */
   public R visit(StructOrUnion n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> ( StructMember() )*
    * </PRE>
    */
   public R visit(StructMemberList n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> QualifiedTypeSpecification()
    * f2 -> Declarators()
    * f3 -> [ &lt;COLON&gt; ConstantExpression() ]
    * f4 -> &lt;SEMICOLON&gt;
    * </PRE>
    */
   public R visit(StructMember n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> EnumDefinition()
    *       | EnumReference()
    * </PRE>
    */
   public R visit(EnumSpecification n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;ENUM&gt;
    * f1 -> [ &lt;IDENTIFIER&gt; ]
    * f2 -> &lt;LBRACE&gt;
    * f3 -> EnumMemberList()
    * f4 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(EnumDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;ENUM&gt;
    * f1 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(EnumReference n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> EnumMember()
    * f1 -> ( &lt;COMMA&gt; EnumMember() )*
    * </PRE>
    */
   public R visit(EnumMemberList n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;IDENTIFIER&gt;
    * f2 -> [ EnumValue() ]
    * </PRE>
    */
   public R visit(EnumMember n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;ASSIGN&gt;
    * f1 -> ConstantExpression()
    * </PRE>
    */
   public R visit(EnumValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Declarator()
    * f1 -> ( &lt;COMMA&gt; Declarator() )*
    * </PRE>
    */
   public R visit(Declarators n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> PointerSpecification()
    * f1 -> DirectDeclarator()
    * </PRE>
    */
   public R visit(Declarator n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> ( QualifierPointerSpecification() )*
    * </PRE>
    */
   public R visit(PointerSpecification n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;STAR&gt;
    * f1 -> ( TypeQualifier() )*
    * </PRE>
    */
   public R visit(QualifierPointerSpecification n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> ( &lt;IDENTIFIER&gt; | &lt;LPAREN&gt; Declarator() &lt;RPAREN&gt; )
    * f1 -> ( ArraySpecification() )*
    * </PRE>
    */
   public R visit(DirectDeclarator n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LBRACKET&gt;
    * f1 -> [ ConstantExpression() ]
    * f2 -> &lt;RBRACKET&gt;
    * </PRE>
    */
   public R visit(ArraySpecification n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> PointerSpecification()
    * f1 -> [ AbstractDirectDeclarator() ]
    * </PRE>
    */
   public R visit(AbstractDeclarator n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt; AbstractDeclarator() &lt;RPAREN&gt; ( ArraySpecification() )*
    *       | ( ArraySpecification() )+
    * </PRE>
    */
   public R visit(AbstractDirectDeclarator n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;INTERFACE&gt;
    * f2 -> [ &lt;UNMANAGED&gt; ]
    * f3 -> FullyQualifiedName()
    * f4 -> [ InterfaceInheritanceSpecification() ]
    * f5 -> InterfaceBody()
    * </PRE>
    */
   public R visit(InterfaceDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;COLON&gt;
    * f1 -> FullyQualifiedName()
    * </PRE>
    */
   public R visit(InterfaceInheritanceSpecification n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt;
    * f1 -> ( MethodDefinition() &lt;SEMICOLON&gt; )*
    * f2 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(InterfaceBody n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> QualifiedTypeSpecification()
    * f2 -> PointerSpecification()
    * f3 -> &lt;IDENTIFIER&gt;
    * f4 -> Parameters()
    * </PRE>
    */
   public R visit(MethodDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt; [ &lt;VOID&gt; ] &lt;RPAREN&gt;
    *       | &lt;LPAREN&gt; ParameterList() &lt;RPAREN&gt;
    * </PRE>
    */
   public R visit(Parameters n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Parameter()
    * f1 -> ( &lt;COMMA&gt; Parameter() )*
    * f2 -> [ &lt;COMMA&gt; &lt;LDOTS&gt; ]
    * </PRE>
    */
   public R visit(ParameterList n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> ( ParameterQualifier() )*
    * f2 -> QualifiedTypeSpecification()
    * f3 -> ( Declarator() | AbstractDeclarator() )
    * </PRE>
    */
   public R visit(Parameter n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IN&gt;
    *       | &lt;OUT&gt;
    * </PRE>
    */
   public R visit(ParameterQualifier n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> LogicalOrExpression()
    * </PRE>
    */
   public R visit(ConstantExpression n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> LogicalAndExpression()
    * f1 -> [ "||" LogicalOrExpression() ]
    * </PRE>
    */
   public R visit(LogicalOrExpression n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> OrExpression()
    * f1 -> [ "&&" LogicalAndExpression() ]
    * </PRE>
    */
   public R visit(LogicalAndExpression n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> XorExpression()
    * f1 -> [ "|" OrExpression() ]
    * </PRE>
    */
   public R visit(OrExpression n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> AndExpression()
    * f1 -> [ "^" XorExpression() ]
    * </PRE>
    */
   public R visit(XorExpression n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> ShiftExpression()
    * f1 -> [ "&" AndExpression() ]
    * </PRE>
    */
   public R visit(AndExpression n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> AdditiveExpression()
    * f1 -> [ ShiftOperation() ShiftExpression() ]
    * </PRE>
    */
   public R visit(ShiftExpression n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> MulExpression()
    * f1 -> [ AdditiveOperation() AdditiveExpression() ]
    * </PRE>
    */
   public R visit(AdditiveExpression n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> CastExpression()
    * f1 -> [ MulOperation() MulExpression() ]
    * </PRE>
    */
   public R visit(MulExpression n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt; QualifiedTypeSpecification() AbstractDeclarator() &lt;RPAREN&gt; CastExpression()
    *       | UnaryExpression()
    * </PRE>
    */
   public R visit(CastExpression n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> [ UnaryOperation() ]
    * f1 -> PrimaryExpression()
    * </PRE>
    */
   public R visit(UnaryExpression n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Literal()
    *       | &lt;LPAREN&gt; ConstantExpression() &lt;RPAREN&gt;
    * </PRE>
    */
   public R visit(PrimaryExpression n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;INTEGER_LITERAL&gt;
    *       | &lt;STRING_LITERAL&gt;
    *       | &lt;CHARACTER_LITERAL&gt;
    *       | &lt;FLOATING_POINT_LITERAL&gt;
    *       | &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(Literal n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LSHIFT&gt;
    *       | &lt;RSHIFT&gt;
    * </PRE>
    */
   public R visit(ShiftOperation n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;PLUS&gt;
    *       | &lt;MINUS&gt;
    * </PRE>
    */
   public R visit(AdditiveOperation n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;STAR&gt;
    *       | &lt;SLASH&gt;
    *       | &lt;PERCENT&gt;
    * </PRE>
    */
   public R visit(MulOperation n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;AMP&gt;
    *       | &lt;STAR&gt;
    *       | &lt;PLUS&gt;
    *       | &lt;MINUS&gt;
    *       | &lt;TILDE&gt;
    *       | &lt;NOT&gt;
    * </PRE>
    */
   public R visit(UnaryOperation n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> ( Annotation() )*
    * </PRE>
    */
   public R visit(Annotations n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;AT&gt;
    * f1 -> FullyQualifiedName()
    * f2 -> [ AnnotationParameters() ]
    * </PRE>
    */
   public R visit(Annotation n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt;
    * f1 -> [ AnnotationValuePairs() | AnnotationValue() ]
    * f2 -> &lt;RPAREN&gt;
    * </PRE>
    */
   public R visit(AnnotationParameters n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> AnnotationValuePair()
    * f1 -> ( &lt;COMMA&gt; AnnotationValuePair() )*
    * </PRE>
    */
   public R visit(AnnotationValuePairs n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;ASSIGN&gt;
    * f2 -> AnnotationValue()
    * </PRE>
    */
   public R visit(AnnotationValuePair n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> StringValue()
    *       | IntegerValue()
    *       | BooleanValue()
    *       | AnnotationAnnotationValue()
    *       | ArrayAnnotationValue()
    *       | NullValue()
    * </PRE>
    */
   public R visit(AnnotationValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> Annotation()
    * </PRE>
    */
   public R visit(AnnotationAnnotationValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt;
    * f1 -> [ AnnotationValue() ( &lt;COMMA&gt; AnnotationValue() )* ]
    * f2 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(ArrayAnnotationValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;STRING_LITERAL&gt;
    * </PRE>
    */
   public R visit(StringValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> [ &lt;MINUS&gt; | &lt;PLUS&gt; ]
    * f1 -> &lt;INTEGER_LITERAL&gt;
    * </PRE>
    */
   public R visit(IntegerValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;BOOLEAN_LITERAL&gt;
    * </PRE>
    */
   public R visit(BooleanValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;NULL&gt;
    * </PRE>
    */
   public R visit(NullValue n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> ( &lt;DOT&gt; &lt;IDENTIFIER&gt; )*
    * </PRE>
    */
   public R visit(FullyQualifiedName n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

}
