//
// Generated by JTB 1.3.2
//

package org.ow2.mind.idl.jtb.visitor;
import org.ow2.mind.idl.jtb.syntaxtree.*;
import java.util.*;

/**
 * All GJ visitors with no argument must implement this interface.
 */

public interface GJNoArguVisitor<R> {

   //
   // GJ Auto class visitors with no argument
   //

   public R visit(NodeList n);
   public R visit(NodeListOptional n);
   public R visit(NodeOptional n);
   public R visit(NodeSequence n);
   public R visit(NodeToken n);

   //
   // User-generated visitor methods below
   //

   /**
    * <PRE>
    * f0 -> ( IncludeDirective() )*
    * f1 -> ( ( TypeDefinition() | ConstantDefinition() ) )*
    * f2 -> InterfaceDefinition()
    * f3 -> [ &lt;SEMICOLON&gt; ]
    * f4 -> &lt;EOF&gt;
    * </PRE>
    */
   public R visit(ITFFile n);

   /**
    * <PRE>
    * f0 -> &lt;PREPROC_START&gt;
    * f1 -> &lt;PREPROC_IFNDEF&gt;
    * f2 -> &lt;PREPROC_IDENTIFIER&gt;
    * f3 -> &lt;PREPROC_ROL&gt;
    * f4 -> &lt;PREPROC_START&gt;
    * f5 -> &lt;PREPROC_DEFINE&gt;
    * f6 -> &lt;PREPROC_IDENTIFIER&gt;
    * f7 -> &lt;PREPROC_ROL&gt;
    * f8 -> ( IncludeDirective() )*
    * f9 -> ( ( TypeDefinition() | ConstantDefinition() ) )*
    * f10 -> &lt;PREPROC_START&gt;
    * f11 -> &lt;PREPROC_ENDIF&gt;
    * f12 -> [ &lt;PREPROC_ROL&gt; ]
    * f13 -> &lt;EOF&gt;
    * </PRE>
    */
   public R visit(IDTFile n);

   /**
    * <PRE>
    * f0 -> &lt;PREPROC_START&gt;
    * f1 -> &lt;PREPROC_INCLUDE&gt;
    * f2 -> &lt;PREPROC_PATH&gt;
    * f3 -> &lt;PREPROC_ROL&gt;
    * </PRE>
    */
   public R visit(IncludeDirective n);

   /**
    * <PRE>
    * f0 -> &lt;PREPROC_START&gt;
    * f1 -> &lt;PREPROC_DEFINE&gt;
    * f2 -> &lt;PREPROC_IDENTIFIER&gt;
    * f3 -> &lt;PREPROC_ROL&gt;
    * </PRE>
    */
   public R visit(ConstantDefinition n);

   /**
    * <PRE>
    * f0 -> ( TypeDefSpecification() | StructOrUnionSpecification() | EnumSpecification() )
    * f1 -> &lt;SEMICOLON&gt;
    * </PRE>
    */
   public R visit(TypeDefinition n);

   /**
    * <PRE>
    * f0 -> &lt;TYPEDEF&gt;
    * f1 -> QualifiedTypeSpecification()
    * f2 -> Declarators()
    * </PRE>
    */
   public R visit(TypeDefSpecification n);

   /**
    * <PRE>
    * f0 -> ( TypeQualifier() )*
    * f1 -> TypeSpecification()
    * </PRE>
    */
   public R visit(QualifiedTypeSpecification n);

   /**
    * <PRE>
    * f0 -> &lt;CONST&gt;
    *       | &lt;VOLATILE&gt;
    * </PRE>
    */
   public R visit(TypeQualifier n);

   /**
    * <PRE>
    * f0 -> TypeDefName()
    *       | StructOrUnionSpecification()
    *       | EnumSpecification()
    *       | TypeSpecifiers()
    * </PRE>
    */
   public R visit(TypeSpecification n);

   /**
    * <PRE>
    * f0 -> FullyQualifiedName()
    * </PRE>
    */
   public R visit(TypeDefName n);

   /**
    * <PRE>
    * f0 -> ( &lt;VOID&gt; | &lt;CHAR&gt; | &lt;SHORT&gt; | &lt;INT&gt; | &lt;LONG&gt; | &lt;FLOAT&gt; | &lt;DOUBLE&gt; | &lt;SIGNED&gt; | &lt;UNSIGNED&gt; | &lt;STRING&gt; | &lt;INT8_T&gt; | &lt;UINT8_T&gt; | &lt;INT16_T&gt; | &lt;UINT16_T&gt; | &lt;INT32_T&gt; | &lt;UINT32_T&gt; | &lt;INT64_T&gt; | &lt;UINT64_T&gt; | &lt;INTPTR_T&gt; | &lt;UINTPTR_T&gt; )+
    * </PRE>
    */
   public R visit(TypeSpecifiers n);

   /**
    * <PRE>
    * f0 -> StructOrUnionDefinition()
    *       | StructOrUnionReference()
    * </PRE>
    */
   public R visit(StructOrUnionSpecification n);

   /**
    * <PRE>
    * f0 -> StructOrUnion()
    * f1 -> [ &lt;IDENTIFIER&gt; ]
    * f2 -> &lt;LBRACE&gt;
    * f3 -> StructMemberList()
    * f4 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(StructOrUnionDefinition n);

   /**
    * <PRE>
    * f0 -> StructOrUnion()
    * f1 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(StructOrUnionReference n);

   /**
    * <PRE>
    * f0 -> &lt;STRUCT&gt;
    *       | &lt;UNION&gt;
    * </PRE>
    */
   public R visit(StructOrUnion n);

   /**
    * <PRE>
    * f0 -> ( StructMember() )*
    * </PRE>
    */
   public R visit(StructMemberList n);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> QualifiedTypeSpecification()
    * f2 -> Declarators()
    * f3 -> [ &lt;COLON&gt; ConstantExpression() ]
    * f4 -> &lt;SEMICOLON&gt;
    * </PRE>
    */
   public R visit(StructMember n);

   /**
    * <PRE>
    * f0 -> EnumDefinition()
    *       | EnumReference()
    * </PRE>
    */
   public R visit(EnumSpecification n);

   /**
    * <PRE>
    * f0 -> &lt;ENUM&gt;
    * f1 -> [ &lt;IDENTIFIER&gt; ]
    * f2 -> &lt;LBRACE&gt;
    * f3 -> EnumMemberList()
    * f4 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(EnumDefinition n);

   /**
    * <PRE>
    * f0 -> &lt;ENUM&gt;
    * f1 -> &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(EnumReference n);

   /**
    * <PRE>
    * f0 -> EnumMember()
    * f1 -> ( &lt;COMMA&gt; EnumMember() )*
    * </PRE>
    */
   public R visit(EnumMemberList n);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;IDENTIFIER&gt;
    * f2 -> [ EnumValue() ]
    * </PRE>
    */
   public R visit(EnumMember n);

   /**
    * <PRE>
    * f0 -> &lt;ASSIGN&gt;
    * f1 -> ConstantExpression()
    * </PRE>
    */
   public R visit(EnumValue n);

   /**
    * <PRE>
    * f0 -> Declarator()
    * f1 -> ( &lt;COMMA&gt; Declarator() )*
    * </PRE>
    */
   public R visit(Declarators n);

   /**
    * <PRE>
    * f0 -> PointerSpecification()
    * f1 -> DirectDeclarator()
    * </PRE>
    */
   public R visit(Declarator n);

   /**
    * <PRE>
    * f0 -> ( QualifierPointerSpecification() )*
    * </PRE>
    */
   public R visit(PointerSpecification n);

   /**
    * <PRE>
    * f0 -> &lt;STAR&gt;
    * f1 -> ( TypeQualifier() )*
    * </PRE>
    */
   public R visit(QualifierPointerSpecification n);

   /**
    * <PRE>
    * f0 -> ( &lt;IDENTIFIER&gt; | &lt;LPAREN&gt; Declarator() &lt;RPAREN&gt; )
    * f1 -> ( ArraySpecification() )*
    * </PRE>
    */
   public R visit(DirectDeclarator n);

   /**
    * <PRE>
    * f0 -> &lt;LBRACKET&gt;
    * f1 -> [ ConstantExpression() ]
    * f2 -> &lt;RBRACKET&gt;
    * </PRE>
    */
   public R visit(ArraySpecification n);

   /**
    * <PRE>
    * f0 -> PointerSpecification()
    * f1 -> [ AbstractDirectDeclarator() ]
    * </PRE>
    */
   public R visit(AbstractDeclarator n);

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt; AbstractDeclarator() &lt;RPAREN&gt; ( ArraySpecification() )*
    *       | ( ArraySpecification() )+
    * </PRE>
    */
   public R visit(AbstractDirectDeclarator n);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> &lt;INTERFACE&gt;
    * f2 -> [ &lt;UNMANAGED&gt; ]
    * f3 -> FullyQualifiedName()
    * f4 -> [ InterfaceInheritanceSpecification() ]
    * f5 -> InterfaceBody()
    * </PRE>
    */
   public R visit(InterfaceDefinition n);

   /**
    * <PRE>
    * f0 -> &lt;COLON&gt;
    * f1 -> FullyQualifiedName()
    * </PRE>
    */
   public R visit(InterfaceInheritanceSpecification n);

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt;
    * f1 -> ( MethodDefinition() &lt;SEMICOLON&gt; )*
    * f2 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(InterfaceBody n);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> QualifiedTypeSpecification()
    * f2 -> PointerSpecification()
    * f3 -> &lt;IDENTIFIER&gt;
    * f4 -> Parameters()
    * </PRE>
    */
   public R visit(MethodDefinition n);

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt; [ &lt;VOID&gt; ] &lt;RPAREN&gt;
    *       | &lt;LPAREN&gt; ParameterList() &lt;RPAREN&gt;
    * </PRE>
    */
   public R visit(Parameters n);

   /**
    * <PRE>
    * f0 -> Parameter()
    * f1 -> ( &lt;COMMA&gt; Parameter() )*
    * f2 -> [ &lt;COMMA&gt; &lt;LDOTS&gt; ]
    * </PRE>
    */
   public R visit(ParameterList n);

   /**
    * <PRE>
    * f0 -> Annotations()
    * f1 -> ( ParameterQualifier() )*
    * f2 -> QualifiedTypeSpecification()
    * f3 -> ( Declarator() | AbstractDeclarator() )
    * </PRE>
    */
   public R visit(Parameter n);

   /**
    * <PRE>
    * f0 -> &lt;IN&gt;
    *       | &lt;OUT&gt;
    * </PRE>
    */
   public R visit(ParameterQualifier n);

   /**
    * <PRE>
    * f0 -> LogicalOrExpression()
    * </PRE>
    */
   public R visit(ConstantExpression n);

   /**
    * <PRE>
    * f0 -> LogicalAndExpression()
    * f1 -> [ "||" LogicalOrExpression() ]
    * </PRE>
    */
   public R visit(LogicalOrExpression n);

   /**
    * <PRE>
    * f0 -> OrExpression()
    * f1 -> [ "&&" LogicalAndExpression() ]
    * </PRE>
    */
   public R visit(LogicalAndExpression n);

   /**
    * <PRE>
    * f0 -> XorExpression()
    * f1 -> [ "|" OrExpression() ]
    * </PRE>
    */
   public R visit(OrExpression n);

   /**
    * <PRE>
    * f0 -> AndExpression()
    * f1 -> [ "^" XorExpression() ]
    * </PRE>
    */
   public R visit(XorExpression n);

   /**
    * <PRE>
    * f0 -> ShiftExpression()
    * f1 -> [ "&" AndExpression() ]
    * </PRE>
    */
   public R visit(AndExpression n);

   /**
    * <PRE>
    * f0 -> AdditiveExpression()
    * f1 -> [ ShiftOperation() ShiftExpression() ]
    * </PRE>
    */
   public R visit(ShiftExpression n);

   /**
    * <PRE>
    * f0 -> MulExpression()
    * f1 -> [ AdditiveOperation() AdditiveExpression() ]
    * </PRE>
    */
   public R visit(AdditiveExpression n);

   /**
    * <PRE>
    * f0 -> CastExpression()
    * f1 -> [ MulOperation() MulExpression() ]
    * </PRE>
    */
   public R visit(MulExpression n);

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt; QualifiedTypeSpecification() AbstractDeclarator() &lt;RPAREN&gt; CastExpression()
    *       | UnaryExpression()
    * </PRE>
    */
   public R visit(CastExpression n);

   /**
    * <PRE>
    * f0 -> [ UnaryOperation() ]
    * f1 -> PrimaryExpression()
    * </PRE>
    */
   public R visit(UnaryExpression n);

   /**
    * <PRE>
    * f0 -> Literal()
    *       | &lt;LPAREN&gt; ConstantExpression() &lt;RPAREN&gt;
    * </PRE>
    */
   public R visit(PrimaryExpression n);

   /**
    * <PRE>
    * f0 -> &lt;INTEGER_LITERAL&gt;
    *       | &lt;STRING_LITERAL&gt;
    *       | &lt;CHARACTER_LITERAL&gt;
    *       | &lt;FLOATING_POINT_LITERAL&gt;
    *       | &lt;IDENTIFIER&gt;
    * </PRE>
    */
   public R visit(Literal n);

   /**
    * <PRE>
    * f0 -> &lt;LSHIFT&gt;
    *       | &lt;RSHIFT&gt;
    * </PRE>
    */
   public R visit(ShiftOperation n);

   /**
    * <PRE>
    * f0 -> &lt;PLUS&gt;
    *       | &lt;MINUS&gt;
    * </PRE>
    */
   public R visit(AdditiveOperation n);

   /**
    * <PRE>
    * f0 -> &lt;STAR&gt;
    *       | &lt;SLASH&gt;
    *       | &lt;PERCENT&gt;
    * </PRE>
    */
   public R visit(MulOperation n);

   /**
    * <PRE>
    * f0 -> &lt;AMP&gt;
    *       | &lt;STAR&gt;
    *       | &lt;PLUS&gt;
    *       | &lt;MINUS&gt;
    *       | &lt;TILDE&gt;
    *       | &lt;NOT&gt;
    * </PRE>
    */
   public R visit(UnaryOperation n);

   /**
    * <PRE>
    * f0 -> ( Annotation() )*
    * </PRE>
    */
   public R visit(Annotations n);

   /**
    * <PRE>
    * f0 -> &lt;AT&gt;
    * f1 -> FullyQualifiedName()
    * f2 -> [ AnnotationParameters() ]
    * </PRE>
    */
   public R visit(Annotation n);

   /**
    * <PRE>
    * f0 -> &lt;LPAREN&gt;
    * f1 -> [ AnnotationValuePairs() | AnnotationValue() ]
    * f2 -> &lt;RPAREN&gt;
    * </PRE>
    */
   public R visit(AnnotationParameters n);

   /**
    * <PRE>
    * f0 -> AnnotationValuePair()
    * f1 -> ( &lt;COMMA&gt; AnnotationValuePair() )*
    * </PRE>
    */
   public R visit(AnnotationValuePairs n);

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> &lt;ASSIGN&gt;
    * f2 -> AnnotationValue()
    * </PRE>
    */
   public R visit(AnnotationValuePair n);

   /**
    * <PRE>
    * f0 -> StringValue()
    *       | IntegerValue()
    *       | BooleanValue()
    *       | AnnotationAnnotationValue()
    *       | ArrayAnnotationValue()
    *       | NullValue()
    * </PRE>
    */
   public R visit(AnnotationValue n);

   /**
    * <PRE>
    * f0 -> Annotation()
    * </PRE>
    */
   public R visit(AnnotationAnnotationValue n);

   /**
    * <PRE>
    * f0 -> &lt;LBRACE&gt;
    * f1 -> [ AnnotationValue() ( &lt;COMMA&gt; AnnotationValue() )* ]
    * f2 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(ArrayAnnotationValue n);

   /**
    * <PRE>
    * f0 -> &lt;STRING_LITERAL&gt;
    * </PRE>
    */
   public R visit(StringValue n);

   /**
    * <PRE>
    * f0 -> [ &lt;MINUS&gt; | &lt;PLUS&gt; ]
    * f1 -> &lt;INTEGER_LITERAL&gt;
    * </PRE>
    */
   public R visit(IntegerValue n);

   /**
    * <PRE>
    * f0 -> &lt;BOOLEAN_LITERAL&gt;
    * </PRE>
    */
   public R visit(BooleanValue n);

   /**
    * <PRE>
    * f0 -> &lt;NULL&gt;
    * </PRE>
    */
   public R visit(NullValue n);

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> ( &lt;DOT&gt; &lt;IDENTIFIER&gt; )*
    * </PRE>
    */
   public R visit(FullyQualifiedName n);

}

